package hexagon.resource

import scala.collection.mutable.Set

object Resource {
  private val resources = Set.empty[Resource]

  def freeAllResources(): Unit = {
    resources.clone().foreach(_.free)
  }
}

abstract class Resource {
  Resource.resources += this

  protected final def deleteResource(): Unit = Resource.resources -= this

  protected def free(): Unit
}
